<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PartnerTaxRegistrationList StructType
 * @subpackage Structs
 */
class PartnerTaxRegistrationList extends AbstractStructBase
{
    /**
     * The partnerTaxRegistration
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PartnerTaxRegistration[]
     */
    public $partnerTaxRegistration;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for PartnerTaxRegistrationList
     * @uses PartnerTaxRegistrationList::setPartnerTaxRegistration()
     * @uses PartnerTaxRegistrationList::setReplaceAll()
     * @param \StructType\PartnerTaxRegistration[] $partnerTaxRegistration
     * @param bool $replaceAll
     */
    public function __construct(array $partnerTaxRegistration = array(), $replaceAll = true)
    {
        $this
            ->setPartnerTaxRegistration($partnerTaxRegistration)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get partnerTaxRegistration value
     * @return \StructType\PartnerTaxRegistration[]|null
     */
    public function getPartnerTaxRegistration()
    {
        return $this->partnerTaxRegistration;
    }
    /**
     * This method is responsible for validating the values passed to the setPartnerTaxRegistration method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPartnerTaxRegistration method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePartnerTaxRegistrationForArrayConstraintsFromSetPartnerTaxRegistration(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $partnerTaxRegistrationListPartnerTaxRegistrationItem) {
            // validation for constraint: itemType
            if (!$partnerTaxRegistrationListPartnerTaxRegistrationItem instanceof \StructType\PartnerTaxRegistration) {
                $invalidValues[] = is_object($partnerTaxRegistrationListPartnerTaxRegistrationItem) ? get_class($partnerTaxRegistrationListPartnerTaxRegistrationItem) : sprintf('%s(%s)', gettype($partnerTaxRegistrationListPartnerTaxRegistrationItem), var_export($partnerTaxRegistrationListPartnerTaxRegistrationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The partnerTaxRegistration property can only contain items of type \StructType\PartnerTaxRegistration, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set partnerTaxRegistration value
     * @throws \InvalidArgumentException
     * @param \StructType\PartnerTaxRegistration[] $partnerTaxRegistration
     * @return \StructType\PartnerTaxRegistrationList
     */
    public function setPartnerTaxRegistration(array $partnerTaxRegistration = array())
    {
        // validation for constraint: array
        if ('' !== ($partnerTaxRegistrationArrayErrorMessage = self::validatePartnerTaxRegistrationForArrayConstraintsFromSetPartnerTaxRegistration($partnerTaxRegistration))) {
            throw new \InvalidArgumentException($partnerTaxRegistrationArrayErrorMessage, __LINE__);
        }
        $this->partnerTaxRegistration = $partnerTaxRegistration;
        return $this;
    }
    /**
     * Add item to partnerTaxRegistration value
     * @throws \InvalidArgumentException
     * @param \StructType\PartnerTaxRegistration $item
     * @return \StructType\PartnerTaxRegistrationList
     */
    public function addToPartnerTaxRegistration(\StructType\PartnerTaxRegistration $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PartnerTaxRegistration) {
            throw new \InvalidArgumentException(sprintf('The partnerTaxRegistration property can only contain items of type \StructType\PartnerTaxRegistration, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->partnerTaxRegistration[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\PartnerTaxRegistrationList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
